import java.awt.*;
import java.awt.print.*;
import java.awt.event.*;
public class PrintResolution implements ActionListener


{
    private PrinterJob pj;
    private Book book;
    private PageFormat dPF;
    private Object o;
    private double factor;
    private boolean dlg;
    private Font f;
    
    public PrintResolution(Object o, int dpi, boolean dlg)     {		/*creates a new printerjob*/
        
        f = new Font("Helvetica Bold",Font.PLAIN, 14);
        pj = PrinterJob.getPrinterJob();		/*sets pagelayout to default*/
        
        dPF = pj.defaultPage();
        
        this.o = o;		/*calculates new scaling factor*/
        factor = dpi / 72.;
        this.dlg = dlg;	}
    
    public void print( ) {		/*if a printer was selected in dialog*/
//               pj.printDialog();
        try {				/*checks if u wana have a paperdialog*/
            //                if (dlg) {
//                                            dPF = pj.pageDialog(dPF);
            //                }				/*checks if Component*/
            //                if (o instanceof Component) {
            //                    pj.setPrintable(new CompPrint(), dPF);
            //                    /*checks if Image*/
            //                } else if (o instanceof Image) {
            pj.setPrintable(new ImagePrint(), dPF);
            //                }
            pj.print();
        } catch(PrinterException e)	{
            e.printStackTrace();
        }
    }
    //    }
    
    /*a class which prints images*/
    private class ImagePrint implements Printable {
        public int print(Graphics g, PageFormat pf, int page) {
            Image i = (Image) o;
            Graphics2D g2d = (Graphics2D) g;
            g2d.translate(pf.getImageableX(), pf.getImageableY());
            g2d.scale( 1 / factor, 1 / factor);
            g2d.drawImage(i, 0, 45, null);
            g2d.setFont(f);
            g2d.drawString("Einzelbild aus dem Video ''Lift''" ,525,665);
            g2d.drawString("von Tina Tonagel " ,611,680);
            if (page >= 1) {
                return Printable.NO_SUCH_PAGE;
            } else {
                return Printable.PAGE_EXISTS;
            }
        }
    }
    
    public void actionPerformed(ActionEvent e) {
        print();
    }
}
